// Ex.cpp
// Isabel H. Manssour
          
#include <gl/glut.h>
#include <stdio.h>           
           
GLfloat win;
// ** Declare as variveis globais responsveis pela movimentao dos objetos          
                      
void DesenhaBorboleta()
{
	glLineWidth(2);
	glBegin(GL_LINE_LOOP);
		glVertex2f(0.5,1.0);
		glVertex2f(0.5,-1.0);
		glVertex2f(-0.5,1.0);
        glVertex2f(-0.5,-1.0);
	glEnd();
}
           
void DesenhaBraco()
{
	glLineWidth(2);
	glBegin(GL_LINE_LOOP);
		glVertex2f(1.0,4.6);
		glVertex2f(1.0,-0.8);
		glVertex2f(-1.0,-0.8);
		glVertex2f(-1.0,4.6);
	glEnd();
	glPointSize(2);
	glBegin(GL_POINTS);
		glVertex2i(0,0);
	glEnd();
}
           
void DesenhaBase()
{
	glLineWidth(2);
	glBegin(GL_LINE_LOOP);
		glVertex2f(1.5,1);
        glVertex2f(1.5,-1.5);
		glVertex2f(1.0,-1.5);
        glVertex2f(1.0,-1);
        glVertex2f(-1.0,-1);
        glVertex2f(-1.0,-1.5);
        glVertex2f(-1.5,-1.5);
        glVertex2f(-1.5,1);
	glEnd();
}
           
// Funo callback de redesenho da janela de visualizao
void Desenha(void)
{
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
                              
    glClear(GL_COLOR_BUFFER_BIT);
                   
    // ** Chame as funes adequadas para fazer o desenho
                                       
    glFlush();
}

// Funo responsvel por inicializar parmetros e variveis
void Inicializa (void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

	win = 20;

    //** Faa aqui a inicializao das variveis globais

	printf(" Setas para esquerda e para direita movimentam a base (vermelha)");
	printf("\n Home e End rotacionam o braco 1 (verde)");
	printf("\n PageUP e PageDn rotacionam o braco 2 (azul)");
}

// Callback chamada quando o tamanho da janela  alterado
void AlteraTamanhoJanela(GLsizei w, GLsizei h)
{
	// Especifica as dimenses da Viewport
	glViewport(0, 0, w, h);

	// Inicializa o sistema de coordenadas
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Estabelece a janela de seleo (esquerda, direita, inferior, 
	// superior) mantendo a proporo com a janela de visualizao
	gluOrtho2D (-win, win, -win, win);
}          
           
// Funo callback chamada pela GLUT a cada intervalo de tempo
void Anima(int value)
{
    // ** Altere aqui a(s) varivel(is) responsvel(is) pelo movimento da "borboleta"

	glutPostRedisplay();
    glutTimerFunc(120,Anima, 1);
}

// Callback chamada quando as teclas especiais so pressionadas
void TeclasEspeciais(int key, int x, int y)
{
     // Move a base
     if(key == GLUT_KEY_LEFT)
            // ** Incremente/Decremente a varivel adequada
     if(key == GLUT_KEY_RIGHT)
	        // ** Incremente/Decremente a varivel adequada

     // Rotaciona braco1
     if(key == GLUT_KEY_HOME)
            // ** Incremente/Decremente a varivel adequada
     if(key == GLUT_KEY_END)
            // ** Incremente/Decremente a varivel adequada
              
     // Rotaciona braco2
     if(key == GLUT_KEY_PAGE_UP)
            // ** Incremente/Decremente a varivel adequada
     if(key == GLUT_KEY_PAGE_DOWN)
            // ** Incremente/Decremente a varivel adequada              
                                                
     glutPostRedisplay();
}

// Programa Principal 
int main(void)
{
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(400,350);
	glutInitWindowPosition(10,10);
	glutCreateWindow("Exemplo");
	Inicializa();
	glutDisplayFunc(Desenha);
	glutReshapeFunc(AlteraTamanhoJanela);
	glutSpecialFunc(TeclasEspeciais);
	glutTimerFunc(120, Anima, 1);
	glutMainLoop();
	return 0;
}
